//+------------------------------------------------------------------+
//|                                         Range_Volume_Ratio_S.mq4 |
//|                               Copyright  2014, Gehtsoft USA LLC |
//|                                            http://fxcodebase.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2014, Gehtsoft USA LLC"
#property link      "http://fxcodebase.com"

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1  Yellow
#property indicator_color2  Red

extern int    Method          = 0;  // 0 - Open/Close method, 1 - High/Low method
extern int    MA_Length       = 15;                     
extern int    MA_Method       = 1;  // 0 - SMA, 1 - EMA, 2 - SMMA, 3 - LWMA
extern bool   alertsOn        = true;
extern bool   alertsOnCurrent = false;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = true;
extern bool   alertsNotify    = false;
extern bool   alertsEmail     = false;
extern string soundFile       = "alert2.wav";

double RVR[];
double Signal[];
double trend[];

int init()
{
   IndicatorBuffers(3);
   SetIndexBuffer(0,RVR);   SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,Signal);
   SetIndexBuffer(2,trend);
   IndicatorShortName("Range Volume Ratio smoothed oscillator");
return(0);
}

int deinit()
{

 return(0);
}

int start()
{
   int counted_bars = IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars > 0) counted_bars--;
           int limit = MathMin(Bars-counted_bars,Bars-1);
           
           
    for(int pos=limit; pos>=0; pos--)
    {
       if (Method==0)
       {
          RVR[pos]=MathAbs(Open[pos]-Close[pos])/(Volume[pos]*Point);
       }
       else
       {
          RVR[pos]=(High[pos]-Low[pos])/(Volume[pos]*Point);
       }
  
     } 
 
    for(pos=limit; pos>=0; pos--) 
    {
       Signal[pos] = iMAOnArray(RVR,0,MA_Length,0,MA_Method,pos);
       trend[pos]  = trend[pos+1];
          if (RVR[pos]>Signal[pos]) trend[pos] = 1;
          if (RVR[pos]<Signal[pos]) trend[pos] =-1;
    }
    
    //
    //
    //
    //
    //
      
    if (alertsOn)
    {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1;
      if (trend[whichBar] != trend[whichBar+1])
      if (trend[whichBar] == 1)
            doAlert("crossing signal up");
      else  doAlert("crossing signal down");       
    }
return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," Range Volume Ratio ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsNotify)  SendNotification(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," Range Volume Ratio  "),message);
             if (alertsSound)   PlaySound(soundFile);
      }
}
      

